# -*- coding: utf-8 -*-
from setuphelpers import *


def install():
    # Declaring local variables
    bin_name = glob.glob('memreduct-*-setup.exe')[0]

    uninstall_older_version()

    # Installing the software
    install_exe_if_needed(
        bin_name,
        silentflags='/S',
        key='memreduct',
        min_version=control.get_software_version(),
    )
    # The uninstall.exe does't works ... Need to do it manually
    uninstallkey.clear()

def uninstall():

    killalltasks(ensure_list(control.impacted_process))

    for soft in installed_softwares("memreduct"):
        install_folder = soft['install_location'].replace('"', '')
        remove_tree(install_folder, ignore_errors=True)
        unregister_uninstall(soft['key'])


def uninstall_older_version():

    killalltasks(ensure_list(control.impacted_process))

    for soft in installed_softwares("memreduct"):
        if Version(soft['version']) < Version(control.get_software_version()):
            install_folder = soft['install_location'].replace('"', '')
            remove_tree(install_folder, ignore_errors=True)
            unregister_uninstall(soft['key'])